(*---------------------------------------------*)
(*                FRAGMENT.INC                 *)
(*---------------------------------------------*)
CONST
Beginn_Ausnahmen: ARRAY[0..46] OF CHAR =
   ('A','B','E','R',' ','A','N','A',' ','A','N',
    'I',' ','E','I','N','I',' ','D','E','S','T',
    ' ','G','E','I',' ','I','N','I',' ','I','N',
    'S',' ','N','A','C','H','T',' ','U','N','I',
    'V',' ',#255);

Vorsilben: ARRAY[0..30] OF CHAR =
   ('A','B',' ','A','N',' ','A','U','F',' ','A',
    'U','S',' ','N','A','C','H',' ','U','N',' ',
    'V','E','R',' ','V','O','R',' ',#255);

Beginn_Spezial: ARRAY[0..157] OF CHAR =
   ('A','L','T',' ','B','E','R','G',' ','B','E',
    'T','T',' ','E','I','N',' ',    'E','R','D',
    ' ','F','E','S','T',' ','F','E','T','T',' ',
    'G','E','L','D',' ','H','A','U','S',' ','L',
    'A','N','G',' ','L','E','I','T',' ','M','A',
    'C','H','T',' ','M','A','U','S',' ','M','E',
    'N','S','C','H',' ','N','E','T','Z',' ','N',
    'O','R','D',' ','N','','C','H','S','T',' ',
    'O','B','E','R',' ','O','S','T',' ','R','E',
    'I','T',' ','R','','C','K',' ','S','C','H',
    'U','L',' ','S','P','I','E','L',' ','S','',
    'D',' ','T','E','S','T',' ','T','I','E','F',
    ' ','W','A','S','C','H',' ','W','E','I','T',
    ' ','W','E','T','T',' ','W','E','G',' ','W',
    'E','S','T',' ',#255);

Beginn_5: ARRAY[0..27] OF CHAR =
   ('D','U','R','C','H',' ','L','E','T','Z','T',
    'E','N','D',' ','S','P','O','R','T',' ','T',
    'R','A','N','S',' ',#255);

Beginn_4: ARRAY[0..20] OF CHAR =
   ('D','O','R','T',' ','H','O','C','H',' ','Z',
    'E','I','T',' ','','B','E','R',' ',#255);

Beginn_3: ARRAY[0..29] OF CHAR =
   ('C','H','A',' ','D','A','R',' ','E','M','P',
    'F',' ','E','N','T',' ','H','I','N',' ','H',
    'E','R',' ','M','I','T',' ',#255);

Beginn_2: ARRAY[0..72] OF CHAR =
   ('B','E','E','H',' ','B','E','E','I',' ','B',
    'E','E','N',' ','B','E','E','R','D',' ','B',
    'E','I','N','H',' ','B','E','I','R','R',' ',
    'B','E','O','B',' ','B','E','U','N',' ','B',
    'E','U','R',' ','E','R',' ','G','E',' ','I',
    'N',' ','K','O','O','R',' ','O','K','T',' ',
    'U','M',' ','U','R',' ',#255);

Diphthong: ARRAY[0..21] OF CHAR =
   ('A','I',' ','A','U',' ','A','Y',' ','E','I',
    ' ','E','U',' ','E','Y',' ','','U',' ',
    #255);

Vokal_Trenn: ARRAY[0..36] OF CHAR =
   ('E','A',' ','E','',' ','E','',' ','E','',
    ' ','I','I',' ','I','',' ','I','',' ','I',
    '',' ','O','A',' ','O','E',' ','U','E',' ',
    'U','U',' ',#255);

Konsonant_Beginn: ARRAY[0..101] OF CHAR =
   ('B','L',' ','B','R',' ','C','H',' ','D','R',
    ' ','F','L',' ','F','R',' ','G','L',' ','G',
    'R',' ','K','L',' ','K','N',' ','K','R',' ',
    'P','F','L',' ','P','F',' ','P','H',' ','P',
    'L',' ','P','R',' ','S','C','H','L',' ','S',
    'C','H','M',' ','S','C','H','N',' ','S','C',
    'H','R',' ','S','C','H','W',' ','S','T','R',
    ' ','S','P','R',' ','S','C','H',' ','S','P',
    ' ','S','T',' ','T','H',' ','T','R',' ','Z',
    'W',' ',#255);

Konsonant_Ende: ARRAY[0..330] OF CHAR =
   ('B','S',' ','B',' ','C','H','T','S',' ','C',
    'H','S',' ','C','H','T',' ','C','K','T',' ',
    'C','H',' ','C','K',' ','D',' ','F','F',' ',
    'F','S',' ','F',' ','G','S',' ','G',' ','H',
    'R','S',' ','H','L',' ','H','M',' ','H','N',
    ' ','H','R',' ','H','T',' ','H',' ','K','T',
    ' ','K',' ','L','B','S','T',' ','L','S','C',
    'H',' ','L','C','H',' ','L','F','S',' ','L',
    'K','S',' ','L','T','S',' ','L','B',' ','L',
    'D',' ','L','F',' ','L','G',' ','L','K',' ',
    'L','L',' ','L','P',' ','L','S',' ','L','T',
    ' ','L',' ','M','P','F',' ','M','T','S',' ',
    'M','M',' ','M','P',' ','M','T',' ','M',' ',
    'N','S','C','H',' ','N','G','S',' ','N','D',
    'S',' ','N','D',' ','N','N',' ','N','F',' ',
    'N','G',' ','N','K',' ','N','S',' ','N','T',
    ' ','N','Z',' ','N',' ','P','F',' ','P','P',
    ' ','P','T',' ','P',' ','R','S','C','H',' ',
    'R','C','H',' ','R','K','T',' ','R','S','T',
    ' ','R','B',' ','R','D',' ','R','F',' ','R',
    'G',' ','R','K',' ','R','M',' ','R','N',' ',
    'R','S',' ','R','T',' ','R','Z',' ','R',' ',
    'S','C','H',' ','S','T',' ','S',' ','T','S',
    'C','H',' ','T','Z','T',' ','T','S',' ','T',
    'T',' ','T','Z',' ','T',' ','X','T',' ','Z',
    ' ','',' ','I','d','e','n','t','i','f','i',
    'z','i','e','r','u','n','g',' ','h','i','n',
    'z','u','g','e','z','o','g','e','n',' ','w',
    'e','r','d','e','n','.',' ','H','i','e','r',
    ' ','b','i','t','t','e',' ','n','u','r',' ',
    #255);

Silben_Ende: ARRAY[0..20] OF CHAR =
   ('E','I','T','S',' ','I','O','N','S',' ','N',
    'S','G','E',' ','U','N','G','S',' ',#255);

Nachsilben: ARRAY[0..83] OF CHAR =
   ('H','A','U','S',' ','H','E','I','T',' ','L',
    'A','D','E',' ','L','A','N','D',' ','L','E',
    'R',' ','L','I','C','H',' ','L','I','G',' ',
    'L','O','S',' ','P','H','A',' ','P','R','E',
    'I','S',' ','P','U','N','K','T',' ','R','A',
    'N','D',' ','R','A','U','M',' ','R','E','C',
    'H','T',' ','R','E','I','C','H',' ','R','I',
    'G',' ','R','U','F',' ',#255);

Vokal_Silben: ARRAY[0..303] OF CHAR =
   ('A','B',' ','A','D','R',' ','A','L','G','O',
    ' ','A','K','T',' ','A','M','T',' ','A','N',
    'A','L','Y',' ','A','N','D','E','R',' ','A',
    'N','F',' ','A','N','G','E','B',' ','A','N',
    'L',' ','A','N','T','W','O','R','T',' ','A',
    'N','W','A','L','T',' ','A','N','Z','A','H',
    'L',' ','A','P','F','E','L',' ','A','P','P',
    ' ','A','R','B','E','I','T',' ','A','R','T',
    ' ','A','R','Z','T',' ','A','U','F',' ','A',
    'U','G','E',' ','A','U','S',' ','A','U','T',
    'O',' ','E','B','E','N','E',' ','E','C','K',
    ' ','E','I','M','E','R',' ','E','I','N',' ',
    'E','L','E','M','E','N','T',' ','E','N','E',
    'R','G',' ','E','R','F','A','H','R',' ','E',
    'R','H','A','L',' ','E','R','L','E','B',' ',
    'E','R','K','E','N','N',' ','E','T','W',' ',
    'E','X','P',' ','I','N','D','U',' ','I','N',
    'F',' ','I','N','H',' ','I','N','S',' ','I',
    'M','P',' ','O','B','E','R',' ','O','P','E',
    'R',' ','O','R','D','N',' ','O','R','D','E',
    'N',' ','O','R','G','A',' ','O','R','I','E',
    'N','T',' ','O','R','T',' ','U','H','R',' ',
    'U','N','F','A','L','L',' ','U','N','T','E',
    'R',' ','U','M','S','A','T','Z',' ','U','R',
    'L','A','U','B',' ','U','R','T','E','I','L',
    ' ','','R','Z','T',' ','','N','D','E','R',
    ' ','','M','T',' ','','F','F','N',' ','',
    'K','O',' ','','B',' ',#255);
