ͻ
 Befehlsbersicht:  Standard-Befehle                            
Ķ
 Befehlsname  Funktion                                         
Ķ
 lauf         Ausfhren eines Interpreterprogramms im Speicher 
 drucke       Ausgabe von Text oder Werten auf dem Terminal    
 setze        Zuweisen eines Wertes an eine Variable           
 wenn         Bedingte Programmausfhrung (siehe unten)        
 gehezu       Programm an anderer Stelle fortfhren            
 ende         Ende eines Interpreterprogramms                  
 merke        Kommentar                                        
 liste        Auflisten des Interpreterprogramms               
 neu          Programm im Speicher lschen                     
 lade         Laden eines TXL-Quelltexts                       
 speichere    Speichern eines TXL-Quelltexts (ASCII-Format)    
 verlasse     Verlassen des Interpreters                       
 info         Die Entstehungsgeschichte des TXL-Interpreters   
< weiter >ͼ
|
ͻ
 Befehlsbersicht:  Neue-Befehle                                
Ķ
 Befehlsname  Funktion                                         
Ķ
 hilfe        Hilfe am Bildschirm anzeigen                     
 dos          Startet ein Dos-Programm oder Dos-Shell          
 setfarbe     Stellt die Farbe ein fr zeig,loesch,lese,box    
 zeig         Positionierte Ausgabe auf dem Bildschirm         
 lese         Positioniertes Einlesen einer Variable           
 loesch       Ganzer Bildschirm oder Ausschnitt lschen        
 sbild        Bildschirm in eine Variable sichern              
 rbild        Bildschirm aus einer Var. wieder herstellen      
 attribut     Wechselt die Farbe am Bildschirm                 
 box          Zeichnet eine Box an die angegebenen Koordin.    
 pause        Wartet auf einen Tastendruck                     
 iftaste      Abfrage der letzten Taste von PAUSE und LESE     
 piep         Erzeugt einen Piepton                            
< weiter >ͼ
|
ͻ
 Befehlsbersicht: Weitere neue Befehle         Befehle Seite 3 
Ķ
 Befehlsname  Parameter und Funktion                           
Ķ
 strdef       <String-Var> <Lnge>                             
                Definition eines Strings mit bestimmter Lnge  
 strset       <String-Var> = <String> Stringzuweisung          
 strtoi       <String(-var)> <Integer-Var>                     
                Wandelt String in long um                      
 itostr       <Integer(-var)> <String-Var>                     
                Wandelt long in String um                      
 readln       <String-Var>                                     
              Liest String von Tastatur                        
                                                               
 randomize    Initialisiet den Zufallszahlengenerator          
 random       <Integer(-var)> <Integer-Var>                    
                Setzt 2. Variable auf Zufallszahl, maximal     
                auf den Wert des ersten Parameters             
< weiter >ͼ
|
ͻ
 Verweise auf weitere Befehlsgruppen            Befehle Seite 4 
Ķ
                                                                
 Unterprogramm-Erstellung                                       
   blockbegin,blockend,gosub    -> siehe <gosub>                
                                                                
 Stackverwaltung (push/pop)     -> siehe <push>                 
                                                                
 Gemischte Arrays                                               
   DefArrayElem, SetArrayElem, GetArrayElem                     
                                                                
 Windows         -> eigene Befehlsbersicht                     
 Editor          -> folgt nach der Fensterbefehl-Beschreibung   
 Datenbank       -> 10 ausfhrliche Hilfsseiten                 
 Prprozessor    -> folgt nach der Datenbankbeschreibung        
                                                                
 Mens -> siehe bei Windows                                     
                                                                
ͼ
|
ͻ
 Syntaxbeschreibung:                                            
Ķ
 lauf<Return>                                                   
 drucke "String";<Return>                                       
 drucke Variable;<Return>                                       
 setze  Variable1 = Variable2;<Return>                          
 setze  Variable = (Formel);<Return>                            
 wenn   (Bedingung)<Return>                                     
        (Dann-Zweig)<Return>                                    
        (Sonst-Zweig)<Return>                                   
 gehezu Zeilennummer<Return>                                    
 ende<Return>                                                   
 merke  Kommentar<Return>                                       
 liste<Return>                                                  
 neu<Return>                                                    
 lade      "Filename.Extension"<Return>                         
 speichere "Filename.Extension"<Return>                         
 verlasse<Return>                                               
ͼ
|
<hilfe>
ͻ
 Syntaxbeschreibung: HILFE                                      
Ķ
                                                                
 hilfe<Return>           Zeigt die gesammte Hilfe an.           
                                                                
 hilfe BEFEHL<Return>                                           
 BEFEHL<F1>              Zeigt die Hilfe zum angegebenen Befehl 
 F1                                                             
                                                                
 Hilfetext erweitern oder ndern :                              
                                                                
     Der gesammte Hilfetext ist in der Datei "hilfe.txl"        
     gespeichert.                                               
     Die einzelnen Bildschirmseiten sind durch das Zeichen 124  
     voneinander abgetrennt.                                    
     Um einen Befehl in den SUCH-INDEX aufzunehmen,             
     reicht es, den gewnschten Befehl nach einem Seitenzeichen 
     zwischen die Zeichen '<' und '>' zu schreiben.   <neubef>  
                                                                
ͼ
|
<dos>
ͻ
 Syntaxbeschreibung: DOS                                        
Ķ
                                                                
 dos<Return>             Dos-Shell                              
                                                                
 dos "BEFEHL"<return>    Dosbefehl ausfhren                    
                                                                
ͼ
|
<setfarbe>
ͻ
 Syntaxbeschreibung: SETFARBE                                   
Ķ
                                                                
 setfarbe  n1  n2<Return>     Bildschirmfarbe einstellen fr    
                              zeig, loesch und lese             
                                                                
           n1    : Vordergrund                                  
           n2    : Hintergrund                                  
                                                                
     Farben :                                                   
     --------                                                   
     0 schwarz                                                  
     1 blau                                                     
     2 grn                                                     
     3 trkis                                                   
     4 rot                                                      
     5 lila                                                     
     6 braun                                                    
     7 weiss                                                    
ͼ
|
<zeig>
ͻ
 Syntaxbeschreibung: ZEIG                                       
Ķ
                                                                
 zeig  n1  n2  "String"<Return>            Positionierte        
 zeig  n1  n2  Variable "MASKE"<Return>    Bildschirmausgabe.   
                                                                
       n1        : Zeile    ( 0-24 )                            
       n2        : Spalte   ( 0-79 )                            
       "String"  : Ausgabetext                                  
       Variable  : Ausgabevariable                              
       MASKE     : Ausgabemaske ist nur bei Var-Ausgabe aktiv ! 
                                                                
                   "99999999"      Zahlen                       
                   "99999.99"      Dezimalzahl                  
                   "XXXXXXXX"      String                       
                                                                
 Siehe auch  <SETFARBE>                                         
ͼ
|
<lese>
ͻ
 Syntaxbeschreibung: LESE                           1. Seite    
Ķ
                                                                
 lese  n1  n2   Variable  "MASKE"<return> Einlesen einer        
                                          Variable.             
       n1         : Zeile  ( 0-24 )                             
       n2         : Spalte ( 0-79 )                             
       Variable   : Variable, die eingelesen wird               
       MASKE      : Siehe nchste Seite                         
                   "9999"          Integer einlesen             
                   "9.99"          Dezimalzahl einlesen         
                   "XXXX"          String                       
                   "DD.DD.DDDD"    Datum                        
                                                                
       Mit diesen Tasten wird LESE beendet :                    
                   Return, ESC, Pfeiltasten rauf runter,        
                   Seite auf ab, alle Funktionstasten.          
                                                                
 Siehe auch  <SETFARBE> <IFTASTE>  <nchste Seite>              
< weiter >ͼ
|
ͻ
 Syntaxbeschreibung: LESE                           2. Seite    
Ķ
                                                                
       MASKE :  "99999999"      Zahlen            -1234567890   
                "99999.99"      Dezimalzahl       -.1234567890  
                "XXXXXXXX"      String            Alle Zeichen  
                "DD.DD.DD"      Datum             TT.MM.JJ      
                "DD.DD.DDDD"                      TT.MM.JJJJ    
                                                                
      Jedes Maskenzeichen ergibt eine Eingabestelle.            
                                                                
                                                                
      Sezial :  "@X"  = Maske wird automatisch    Alle Zeichen  
                        auf Stringlnge erstellt.               
                                                                
                "@D"  = Maske wird automatisch    TT.MM.JJJJ    
                        auf Datumfeld erstellt.                 
                                                                
 Siehe auch  <SETFARBE> <IFTASTE>  <vorherige Seite>            
ͼ
|
<loesch>
ͻ
 Syntaxbeschreibung: LOESCH                                     
Ķ
                                                                
 loesch ;<Return>                 Lscht den ganzen Bildschirm  
 loesch  n1  n2  n3  n4 <Return>  Lscht einen Ausschnitt       
                                  auf dem Bildschirm            
                                                                
         n1   :  obere Zeile    ( 0-24 )                        
         n2   :  linke Spalte   ( 0-79 )                        
         n3   :  untere Zeile   ( 0-24 )                        
         n4   :  rechte Spalte  ( 0-79 )                        
                                                                
 Bsp.                                                           
                                                                
         loesch 10 5 20 40<Return>                              
                                                                
                                                                
 Siehe auch  <SETFARBE>                                         
ͼ
|
<sbild>
ͻ
 Syntaxbeschreibung: SBILD    (Im ANSI-Modus nicht aktiv !)     
Ķ
                                                                
 sbild  n1  n2  n3  n4  Str-Var<Return>  Sichert den Bildschirm 
                                         des angegebenen        
                                         Fensters in Variable.  
                                                                
         n1      :  obere Zeile    ( 0-24 )                     
         n2      :  linke Spalte   ( 0-79 )                     
         n3      :  untere Zeile   ( 0-24 )                     
         n4      :  rechte Spalte  ( 0-79 )                     
         Str-Var :  Variable vom Type STRING                    
 Bsp.                                                           
                                                                
         sbild  10 5 20 40 screen<Return>                       
                                                                
                                                                
 Siehe auch  <RBILD>                                            
ͼ
|
<rbild>
ͻ
 Syntaxbeschreibung: RBILD    (Im ANSI-Modus nicht aktiv !)     
Ķ
                                                                
 rbild  n1  n2  n3  n4  Str-Var<Return>  Stellt den Bildschirm  
                                         aus einer Variablen    
                                         wieder her.            
                                                                
         n1      :  obere Zeile    ( 0-24 )                     
         n2      :  linke Spalte   ( 0-79 )                     
         n3      :  untere Zeile   ( 0-24 )                     
         n4      :  rechte Spalte  ( 0-79 )                     
         Str-Var :  Variable vom Type STRING                    
 Bsp.                                                           
                                                                
         rbild  10 5 20 40 screen<Return>                       
                                                                
                                                                
 Siehe auch  <SBILD>                                            
ͼ
|
<attribut>
ͻ
 Syntaxbeschreibung: ATTRIBUT (Im ANSI-Modus nicht aktiv !)     
Ķ
                                                                
 attribut  n1  n2  n3  n4  v  h<Return>  Stellt die Bildschirm- 
                                         farbe im angegebenen   
                                         Fenster um.            
                                         Die Zeichen auf den    
                                         Bildschirm werden      
                                         nicht verndert.       
                                                                
         n1      :  obere Zeile      ( 0-24 )                   
         n2      :  linke Spalte     ( 0-79 )                   
         n3      :  untere Zeile     ( 0-24 )                   
         n4      :  rechte Spalte    ( 0-79 )                   
         v       :  Vordergrundfarbe ( 0-7 )    (Farbtabelle    
         h       :  Hintergrundfarbe ( 0-7 )     bei SETFARBE)  
                                                                
 Siehe auch  <SETFARBE>                                         
ͼ
|
<box>
ͻ
 Syntaxbeschreibung: BOX                                        
Ķ
                                                                
 box    n1  n2  n3  n4 "Box-Str"<Return>  Zeichnet eine Box     
                                          an die angegebenen    
                                          Koordinaten.          
                                                                
         n1        :  obere Zeile    ( 0-24 )                   
         n2        :  linke Spalte   ( 0-79 )                   
         n3        :  untere Zeile   ( 0-24 )                   
         n4        :  rechte Spalte  ( 0-79 )                   
         "Box-Str" :  Variable vom Type STRING                  
                                                                
         Boxstring "12345678#"  ergibt    12222223              
                                          4######8              
                                          4######8              
         "ͻȺ "                      76666665              
                                                                
 Siehe auch  <SETFARBE>                                         
ͼ
|
<pause>
ͻ
 Syntaxbeschreibung:  PAUSE                                     
Ķ
                                                                
 pause<Return>          Das Programm wartet auf einen Tasten-   
                        druck.                                  
                                                                
 Siehe auch  <IFTASTE>                                          
ͼ
|
<iftaste>
ͻ
 Syntaxbeschreibung: IFTASTE                                    
Ķ
                                                                
 iftaste TASTENWERT<Return>       Fragt den Tastenwert ab,      
         (Dann-Zweig)<Return>     mit dem die Funktion          
         (Sonst-Zweig)<Return>    PAUSE oder LESE verlassen     
                                  wurde.                        
                                                                
         Tasten-Tabelle auf der nchsten Seite !                
                                                                
 Siehe auch  <PAUSE>  <LESE>      < nchste Seite >             
ͼ
|
ͻ
 Tastenwert-Tabelle  fr IFTASTE                                
Ķ
      Normal      Shift        Ctrl         Alt                 
      ------      -----        ----         ---                 
      F1  9059    SF1  9084    CF1  9094    AF1  9104           
      F2  9060    SF2  9085    CF2  9095    AF2  9105           
      F3  9061    SF3  9086    CF3  9096    AF3  9106           
      F4  9062    SF4  9087    CF4  9097    AF4  9107           
      F5  9063    SF5  9088    CF5  9098    AF5  9108           
      F6  9064    SF6  9089    CF6  9099    AF6  9109           
      F7  9065    SF7  9090    CF7  9100    AF7  9110           
      F8  9066    SF8  9091    CF8  9101    AF8  9111           
      F9  9067    SF9  9092    CF9  9102    AF9  9112           
      F10 9068    SF10 9093    CF10 9103    AF10 9113           
                                                                
         Escape        9027    Page up       9073               
         Return        9013    Page down     9081               
         Pfeilrunter   9080    Pfeilrauf     9072               
                                                                
ͼ
|
<info>
ͻ
    TXL, die "toolbox language",  ist ein nach allen Seiten     
    offenes Interpreterkonzept fr PC und Atari-ST.             
    Jedem C-Programmierer wird es damit mglich, sich seine     
    eigene Sprache zu gestalten.                                
    Neben der Verwendung der TXL fr Schulungszwecke lassen     
    sich auch hervorragend  rechnerunabhngige  Anwendungen     
    realisieren.   Einzige  Voraussetzung  ist  ein  ANSI-C     
    Compiler.                                                   
    Das Grundgerst fr den TXL-Interpreter  wurde  in  der     
    Zeitschrift toolbox, Heft 9/10'1990 vorgestellt.            
    Wesentliche Erweiterungen  sowie  eine  Windows-Version     
    wurden im Rahmen eines Wettbewerbs in der toolbox 04'91     
    verffentlicht.                                             
    Bezogen werden kann der aktuelle  Grundinterpreter  als     
    toolbox-Special 20.                                         
    Bestellungen richten sie bitte an den DMV-Verlag            
                                          Postfach 250          
                                          3440 Eschwege         
                                                                
ͼ
|
<gosub>
ͻ
 Unterprogramme                                                 
Ķ
                                                                
 Unterprogramme werden mit den Befehlen 'blockbegin' am Anfang  
 und 'blockend' am Ende gekennzeichnet. Mit 'gosub <zeile>'     
 wird ein Unterprogramm aufgerufen. Zur Namensgebung lassen     
 sich Variablen verwenden.                                      
                                                                
 Beispiel :                                                     
                                                                
   010 setze SUB = 100;                                         
   020 gosub SUB                                                
   030 gehezu 200                                               
   100 blockbegin                                               
   110 drucke " Hier Unterprogramm. "                           
   120 blockend                                                 
   200 merke Programmende                                       
                                                                
ͼ
|
<DefArray>
ͻ
 Arrays                                                         
Ķ
                                                                
 Mit "DefArray" definierte Arrays knnen jeden Datentyp - auer 
 weitere Arrays - als Elemente enthalten, auch gemischte        
 Arrays (verschiedene Typen in einem Array) sind mglich.       
                                                                
 Mit "DefArray" mu das Array zuerst definiert werden.          
                                                                
                                                                
   Syntax : DefArray <name> : <dim1> [,dim2] [,dim3]            
                                                                
   Beispiel : DefArray quadrat : 10,10                          
           (definiert ein 10*10 Felder groes Array)            
                                                                
 Mit DefArray knnten Arrays auch redefiniert werden, da aber   
 Speicher verloren geht, wenn bereits Werte in das Array ein-   
 getragen sind, ist von der Redefinition abzuraten.             
                                                                
<weiter>ͼ
|
<SetArrayElem>
ͻ
 Arrays : "SetArrayElem"                                        
Ķ
                                                                
 Syntax : SetArrayElem <name> (dim1 [,dim2[,dim3]]) = <wert>    
                                                                
 Setzt ein Arrayelement an der Stelle (dim1,dim2,dim3), wobei   
 <wert> ein einfacher Typ (Fliekomma, Ganzzahl oder Zeichen)   
 oder ein String sein kann.                                     
                                                                
 Beispiel : SetArrayElem quadrat (4,4) = zahl                   
                                                                
 Anmerkungen :                                                  
   - Hinter dem "=" mu eine Variable stehen, Direktwerte sind  
     nicht erlaubt.                                             
   - Die Numerierung der Elemente beginnt bei 0                 
   - vollstndiges Beispiel auf nchster Seite                  
                                                                
<weiter>ͼ
|
<GetArrayElem>
ͻ
 Arrays : "GetArrayElem"                                        
Ķ
                                                                
 Syntax : GetArrayElem <name> (dim1 [,dim2[,dim3]]) -> <wert>   
                                                                
 Speichert das Element an der Stelle (dim1,dim2,dim3) in <wert>.
 <wert> mu den Typ des Elements haben.                         
                                                                
 Beispiel : DefArray quadrat : 10,10                            
            setze string = "Ein String im Array "               
            setze zahl = 100;                                   
            SetArrayElem quadrat (0,0) = string                 
            SetArrayElem quadrat (0,1) = zahl                   
            GetArrayElem quadrat (0,0) -> string2               
            GetArrayElem quadrat (0,1) -> zahl2                 
            drucke string2                                      
            drucke zahl2                                        
                                                                
ͼ
|
<push>
ͻ
 Integer-Stack                                                  
Ķ
                                                                
 Mit den Befehlen "push" und "pop" ist der Stack, auf dem nur   
 Ganzzahl-Variablen (long) gespeichert werden knnen.           
                                                                
 Die Gre des Stacks ist nur durch den freien Heap begrenzt.   
 Der Stack lt sich gut zur Rckgabe von Funktionswerten       
 in Unterprogrammen oder zur Parameterbergabe benutzen.        
                                                                
   Syntax : push <var oder Konstante>                           
            pop <var>                                           
                                                                
ͼ
|
<window>
ͻ
 Das Window-System (c) 1991 toolbox                                         
Ķ
 Das Windowsystem fr TXL erlaubt soviele Fenster, wie der Heap aufnehmen   
 kann. Einen ersten berblick gibt die Kurzbeschreibung der Befehle:        
                                                                            
   openwindow      Fenster ffnen und Farben definieren                     
   closewindow     Oberstes Fenster schlieen                               
   setcursor       Cursor relativ zum Fenster positionieren                 
   newfirstwindow  Verdecktes Fenster nach vorne bringen                    
   newwindowkoor   Neue Koordinaten fr oberstes Fenster                    
   resizewindow    ndern der Gre des obersten Fensters                   
   movewindow      Verschieben       "     "        "                       
   winreadstring   String in neuem Fenster einlesen (mit Informationszeile) 
   winmessage      Ausgabe einer Meldung in einem Fenster                   
   winwrite        Schnelle Stringausgabe im ob. Fenster                    
                                                                            
< genaue Beschreibung folgt ... >ͼ
|
<openwindow>
ͻ
 Neue Fenster ffnen                               Das Window-System      1 
Ķ
  Syntax                                                                    
                                                                            
    openwindow <x1> <y1> <x2> <y2>   <f1> <f2> <f3> <f4>  [num]             
                                                                            
  Die linke obere Ecke wird mit x1/y1, die rechte untere mit x2/y2          
  angegeben. Es folgen vier Farbangaben :                                   
                                                                            
        f1 : Farbe des Rahmens                                              
        f2 : Farbe des Inneren                                              
        f3 : Farbe fr berschrift (fr Editor)                             
             berschriften fr Nicht-Editor-Fenster knnen mit "winwrite"   
             erzeugt werden.                                                
        f4 : Farbe der Statuszeile (siehe f3)                               
                                                                            
  Im optionalen Parameter [num] wird die Fensternummer des neuen Fensters   
  gespeichert.                                                              
                                                                            
ͼ
|
<resizewindow>
ͻ
 Fensterkoordinaten ndern                         Das Window-System      2 
Ķ
                                                                            
  Der allgemeine Befehl zum ndern der Fensterkoordinaten (des obersten     
  Fensters) ist                                                             
                                                                            
      newwindowkoor <x1> <y1> <x2> <y2>.                                    
                                                                            
  Die Parameternamen sprechen fr sich.                                     
                                                                            
  Nur Breite und Hhe bzw. Position ndern folgende Befehle :               
                                                                            
  (1) resizewindow <rel-x> <rel-y>                                          
  (2) movewindow   <rel-x> <rel-y>                                          
                                                                            
  Bei (1) wird die rechte untere Ecke um relx/rely verschoben, bei (2)      
  das gesamte Fenster. (Da keine negativen Werte mglich sind, mu          
  "newwindowkoor" benutzt werden, um negative Werte zu ersetzen.)           
                                                                            
ͼ
|
<winmessage>
ͻ
 "Automatische Fenster"                            Das Window-System      3 
Ķ
                                                                            
 winmessage <string>     Gibt den <string> und die Aufforderung, eine Taste 
                         zu drcken in einem zentrierten Fenster aus, das   
                         nach einem Tastendruck wieder geschlossen wird.    
                                                                            
 winreadstr <frage> <str-var> <laenge>                                      
                                                                            
                         Gibt in einem zentrierten Fenster <frage> aus und  
                         liest einen String in <str-var> ein. Das Fenster   
                         wird wieder geschlossen. <laenge> gibt an, wie     
                         lang das Eingabefeld minimal sein soll.            
                                                                            
ͼ
|
<winwrite>
ͻ
 weitere Window-Befehle                            Das Window-System      4 
Ķ
                                                                            
 closewindow                Schliet das oberste Fenster                    
                                                                            
 newfirstwindow <num>       Das Fenster <nr> (siehe Openwindow) wird neues  
                            oberes Fenster (behlt aber seine Nummer)       
                                                                            
 winwrite <x> <y> <a> <str> Schreibt <str> mit dem Farbattribut <a> an      
                            die Position x/y des oberen Fensters.           
                            0/0 gibt die linke obere Ecke des Rahmens an.   
                                                                            
 setcursor <x> <y>          Setzt den Cursor an x/y (oberes Fenster)        
                                                                            
 "winwrite" und "setcursor" funktionieren auch ohne geffnetes Fenster.     
                                                                            
ͼ
|
<menue>
ͻ
 Pulldown- und Auswahlmens                                         1 von 2 
Ķ
                                                                            
 Die hier implementierten Pulldownmens werden mit den Cursortasten ge-     
 steuert, und mit <ESC> verlassen. Die Auswahlmens werden nach der Auswahl 
 eines Punktes mit <Return> geschlossen. Beide Formen ffnen kein Fenster,   
 dieses mu also vorher geffnet werden. Dadurch hat man aber die freie     
 Wahl in der Farbe und Position des Mens und die Men-Parameterzeile wird  
 nicht zu lang. Der Auswahlbalken wird in der Rahmenfarbe dargestellt.      
                                                                            
 Syntax :                                                                   
                                                                            
   auswahl <punkt1> <punkt2> ... <punkt n>                                  
   menue <punkt1> <uprog1> ... <punkt n> <uprog n>                          
                                                                            
 Beschreibung wird auf nchster Seite fortgesetzt.                          
                                                                            
ͼ
|
ͻ
 Pulldown- und Auswahlmens                                         2 von 2 
Ķ
                                                                            
 Der "menue"-Befehl ruft im Gegensatz zum "auswahl"-Befehl nach jeder Wahl  
 eines Menpunktes ein Unterprogramm, das durch seine Zeilennummer in den   
 Parametern <uprog x> angegeben ist, auf. Nach Ausfhrung des Unter-        
 programms wird die Menschleife solange weiter durchlaufen, bis <ESC>      
 gedrckt wird. Das Unterprogramm kann natrlich auch aus einer Zeile       
 bestehen, wenn kein "blockbegin" angegeben ist.                            
                                                                            
 Der "auswahl"-Befehl wird nach Auswahl eines Punktes beendet und legt die  
 Nummer des ausgewhlten Punktes auf den Stack (erster Punkt : 1), so da   
 sie mit pop <xxx> ausgelesen werden sollte.                                
                                                                            
 Hinweis : Das Fenster fr die Mens mu nach Beenden des Mens wieder      
           explizit geschlossen werden.                                     
                                                                            
ͼ
|
<edit>
ͻ
 Das Editor-System (c) 1991 toolbox                                         
Ķ
 Das Editorsystem fr TXL erlaubt 10 Editoren, die gleichzeitig             
 verschiedene Dateien bearbeiten knnen und eine Schnittstelle zu TXL       
 besitzen, d.h. (fast) jede Editorfunktion kann durch einen TXL-Befehl      
 simuliert werden. Da 50 Hotkeys fr die Editoren in TXL auf Unterprogramme 
 gelegt werden knnen (Alt/Shift/Ctrl-F1-F10, F1-F10, Alt0-Alt9) knnen     
 so Makros programmiert werden.                                             
                                                                            
   Im Direktmodus bearbeitet "edit" das aktuelle Programm, speichert es     
   am Ende unter "AKTUELL.TXL" und ld es in den Interpreter.               
                                                                            
   "edit <file>" ld eine bestimmte Datei, die explizit gesichert           
   werden mu (z.B. edit "Programm.TXL").                                   
                                                                            
< bersichttafeln folgen ... >ͼ
|
ͻ
 Editorbefehle beim Editieren                              Der Editor    1  
Ķ
 Funktionsnr  Hotkey                                                        
    10         INS                                                          
    11         DEL                                                          
    12       Backspace                                                      
    13        Return                                                        
    14        Ctrl-Y    Zeile lschen                                       
    15       Ctrl-Left  Wort links                                          
    16       Ctrl-Right Wort rechts                                         
    17       Ctrl-B     Blockbeginn setzen                                  
    18       Ctrl-E     Blockende setzen                                    
    19       Ctrl-C     Block kopieren                                      
    20       Ctrl-D     Block lschen                                       
    21       Ctrl-V     Block verschieben                                   
    22       Ctrl-R     Block von Diskette lesen                            
    24       Ctrl-W     Block auf Diskette schreiben                        
                                                                            
ͼ
|
<edfunction>
ͻ
 Editorbefehle beim Editieren                              Der Editor    2  
Ķ
 Funktionsnr  Hotkey                                                        
    23       Ctrl-S     Datei speichern                                     
    25        Home      Cursor an Deteianfang                               
    26        End       Cursor an Textende                                  
    30       Alt-R      Fenster mit Cursortasten in Gre ndern            
    31       Alt-M      Fenster mit Cursortasten verschieben                
    32       Alt-Z      Fenster zoomen, d.h. auf ganzen Bildschirm ausdehnen
    --       Ctrl-T     Aufruf des Prprozessors                            
     0                  Eingabe eines Zeichens                              
  1,2,3,4               Simulieren der                                      
 5,6,7,8,9                  Cursortasten                                    
                                                                            
 Der TXL-Befehl "edfunction <Ed-Nr> <Func-Nr> <Char>" fhrt die               
 Funktionsnummer <Func-Nr> im Editor <Ed-Nr> aus. <Char> ist bei Funktion   
 0 der ASCII-Code des Zeichens, das eingefgt werden soll. (ber Makros     
 sind so auch die unteren Zeichen des Zeichensatzes ansprechbar.)           
                                                                            
ͼ
|
<initeditor>
ͻ
 Editorbefehle fr TXL                                     Der Editor    3  
Ķ
 Grundstzlich ist ein Editor nicht an ein bestimmtes Fenster gebunden;     
 die Ausgaben der Editorfunktionen finden immer im obersten Fenster statt.  
 Da insgesamt 10 Editoren zur Verfgung stehen (Nummer 0 bis 9), ist der    
 erste Parameter der meisten Editor-Befehle die Nummer des angesprochenen   
 Editors. Zuerst wird ein Editor mit                                        
                                                                            
   initeditor <nummer> [file]                                               
                                                                            
 initialisiert. Der optionale Parameter [file] hat den selben Zweck, wie    
 [file] beim "edit"-Befehl. Wird er weggelassen, so ld der Editor das      
 TXL-Programm. Der Befehl                                                   
                                                                            
   editorproc <nummer>                                                      
                                                                            
 veranlat den Editor <nummer>, solange Benutzereingaben zu bearbeiten,     
 bis <ESC> oder <Ctrl>-T gedrckt wird. Der Editor wird durch diese         
 Eingaben nicht automatisch geschlossen (im Unterschied zu "edit").         
ͼ
|
<closeeditor>
ͻ
 Editorbefehle fr TXL                                     Der Editor    4  
Ķ
                                                                            
 Soll der vom Editorinhalt belegte Speicher freigegeben werden, so ist der  
 Befehl                                                                     
                                                                            
    closeeditor <nummer>                                                    
                                                                            
 anzuwenden. Dieser Befehl speichert nur, wenn das aktuelle TXL-Programm    
 geladen ist, und dann in die Datei "aktuell.txl".                          
 Fr Flle, in denen es notwendig wird, den Fensterinhalt fr einen Editor  
 neu darzustellen, ist die Anweisung                                        
                                                                            
    showeditor <nummer>                                                     
                                                                            
 gedacht. Sie ist aber nicht erforderlich, wenn der Text mit "editorproc"   
 bearbeitet wird.                                                           
                                                                            
ͼ
|
<setfkey>
ͻ
 Editorbefehle fr TXL                                     Der Editor    5  
Ķ
                                                                            
 Die Belegung der Hotkeys, die fr alle Editoren gleichzeitig gelten, wird  
 von                                                                        
                                                                            
   setfkey <taste> <zeile>                                                  
                                                                            
 bernommen. Die Zeile mit der Nummer <zeile> wird angesprungen, wenn die   
 angegebene Taste gedrckt wird. Steht in dieser Zeile ein "blockbegin",    
 so wird natrlich der darauf folgende Block ausgefhrt. Die Angabe "0"     
 bei <zeile> bewirkt die Lschung der Hotkey-definition fr <taste>.        
 <taste> kann folgende Werte haben :                                        
                                                                            
   1-10 : F1-F10            31-40 : Alt-F1-F10                              
  11-20 : Shift-F1-F10      41-50 : Alt-1 bis Alt-0                         
  21-30 : Ctrl-F1-F10                                                       
                                                                            
ͼ
|
<insertstring>
ͻ
 Editorbefehle fr TXL                                     Der Editor    6  
Ķ
 Neben der Funktion 0 von "edfunction", die einzelne Zeichen in den Editor  
 eingibt, existiert auch eine Funktion, die Strings in den Editor eingibt:  
                                                                            
   insertstring <editornr> <str>                                            
                                                                            
 Auer dem String / der Stringvariablen wird als erster Parameter die       
 Editornummer erwartet.                                                     
                                                                            
 Das Lesen des Editors in TXL-Programmen kann wort- oder zeilenweise        
 erfolgen :                                                                 
                                                                            
   getedword <editornr> <str-var>                                           
   getedstring <editornr> <str-var>                                         
                                                                            
 Bei "getedword" mu der Cursor auf dem Anfang des Wortes stehen, bei       
 "getedstring" wird die gesamte Zeile in <str-var> gespeichert.             
                                                                            
ͼ
|
ͻ
 Das Datenbankmodul (c) 1991 toolbox                                        
Ķ
                                                                            
 Der Aufbau der Datenfelder ist frei whlbar und wird in einer Datei mit    
 der Endung ".def" gespeichert, sobald einmal definiert. Die Daten werden   
 in gleichnamige Dateien, jedoch mit der Endung ".dat" geschrieben. Als     
 Datenfeldtypen stehen Zeichenfelder mit frei definierbarer Lnge und       
 Integerfelder zur Verfgung. Die Sortierung der Daten erfolgt bei den      
 Strings in einem binren Baum, was aber fr die Programmierung in TXL      
 nicht von Bedeutung ist. Die vielfltigen Mglichkeiten beim Suchen von    
 Datenstzen und sonstigen Funktionen werden auf den folgenden Seiten       
 beschrieben.                                                               
                                                                            
 Bei den Befehlen des Datenbankmoduls ist die Gro/Kleinschreibung zu       
 beachten. ("UnMarkAll" liest sich besser als "unmarkall".)                 
                                                                            
 Es knnen gleichzeitig 3 Datenbanken geffnet werden, daher haben die      
 meisten Datenbankfunktionen einen Parameter <dbnr>, fr den Werte von      
 0 bis 2 erlaubt sind.                                                      
                                                                            
ͼ
|
<DefDB>
ͻ
 Erstellen und ffnen einer Datenbank                Das Datenbankmodul  1  
Ķ
 Zuerst mu der Aufbau eines Datensatzes definiert werden. Dazu wird fr    
 jedes Datenfeld die Funktion                                               
                                                                            
   DefDB <dbnr> <int?> <strlen>                                             
                                                                            
 aufgerufen. <int?>=1 zeigt an, da es sich um ein Integerfeld handelt, der 
 Parameter <strlen> mu vorhanden sein, sein Wert bedeutet aber in diesem   
 Fall nichts. Wenn <int?>=0 ist, wird ein Stringfeld mit der Lnge <strlen> 
 erstellt. Der Parameter <dbnr> gibt die Nummer der Datenbank an (0 bis 2). 
 Die Feldnummer wird automatisch ermittelt: Der erste Aufruf definiert      
 Feld 1, maximal 20 Felder sind mglich.                                    
 Ist die Definition vollstndig, mu sie mit                                
                                                                            
   CreateDB <dbnr> <name>                                                   
                                                                            
 gespeichert werden. Dabei werden die Dateien "<name>.def" und "<name>.dat" 
 neu erzeugt und dabei gelscht, falls sie schon vorhanden sind.            
ͼ
|
<OpenDB>
ͻ
 ffnen und Schlieen einer Datenbank                Das Datenbankmodul  2  
Ķ
                                                                            
 Eine mit "CreateDB" erstellte Datenbank kann mit                           
                                                                            
   OpenDB <dbnr> <name>                                                     
                                                                            
 wieder geffnet werden. Die Definition wird dabei automatisch geladen,     
 die Anwendung von "DefDB" ist hier also nicht ntig.                       
                                                                            
 Nach der Bearbeitung wird die Datenbank mit                                
                                                                            
   CloseFile <dbnr>                                                         
                                                                            
 geschlossen.                                                               
                                                                            
ͼ
|
<WriteDB>
ͻ
 Datenspeicherung                                    Das Datenbankmodul  3  
Ķ
                                                                            
 Das Beschreiben eines Datensatzes erfolgt fr jedes Feld einzeln mit dem   
 Befehl                                                                     
                                                                            
   WriteDB <dbnr> <feldnr> <str> <int>                                      
                                                                            
 In das Feld <feldnr> des aktuellen Datensatzes der Datenbank <dbnr> wird   
 entweder der String <str>, oder der Integer <int> geschrieben, je nach     
 Feldtyp. Beide Parameter mssen angegeben werden. Besonders gnstig        
 ist die Dateneingabe mit Hilfe des Editors, wie im Beispielprogramm        
 demonstriert wird. Mit "AddDB" wird der aktuelle Datensatz auf Diskette    
 gespeichert. Syntax : AddDB <dbnr>                                         
                                                                            
ͼ
|
<ReadDB>
ͻ
 Das Lesen der Daten                                 Das Datenbankmodul  4  
Ķ
 Analog zum Beschreiben eines Satzes funktioniert das Auslesen :            
                                                                            
   ReadDB <dbnr> <feldnr> <str> <int>                                       
                                                                            
 liest das Feld <feldnr> und speichert den Inhalt je nach Typ entweder in   
 <str> oder <int>.                                                          
                                                                            
 Zur Formatierten Ausgabe bessert geeignet ist folgender Befehl:            
                                                                            
   ReadDBForm <dbnr> <feldnr> <str>                                         
                                                                            
 gibt in jedem Fall einen String zurck, der auf die Maximale Lnge des     
 Feldes ausgedehnt ist (linksbndig ausgerichtet), und sich so gut fr      
 Tabellen eignet. Integerwerte werden in einen sechs Zeichen langen String  
 umgewandelt.                                                               
                                                                            
ͼ
|
<GotoBegin>
ͻ
 Bewegung innerhalb der Datenbank                    Das Datenbankmodul  5  
Ķ
                                                                            
 Nach der ffnung befindet sich als aktueller Datensatz ein neuer Satz im   
 Speicher, der hinter allen bisher gespeicherten Datenstzen in der Datei   
 gespeichert wird. Um den aktuellen Datensatz zu ndern, existieren, auer  
 den Datensuchbefehlen, folgende Befehle :                                  
                                                                            
   Befehl                        Zielposition                               
                                                                            
   GotoBegin  <dbnr>             erster Datensatz der Datei                 
   GotoEnd    <dbnr>             ein Satz hinter dem letzten (neuer Satz)   
   GoForward  <dbnr>             einen Satz weiter                          
   GoBackward <dbnr>             einen Satz zurck, Richtung Dateianfang    
   GoTo       <dbnr> <filepos>   Dateiposition (Byte Nr.) <filepos>         
   GoToNr     <dbnr> <satznr>    Datensatz Nummer <satznr>                  
                                                                            
ͼ
|
<MarkCurrent>
ͻ
 Lschen von Datenstzen                             Das Datenbankmodul  6  
Ķ
                                                                            
 Der aktuelle Datensatz wird durch                                          
                                                                            
   MarkCurrent <dbnr> <val>                                                 
                                                                            
 mit <val> markiert. <val> ungleich 0 bedeutet Lschen.                     
                                                                            
   DelMarked <dbnr>                                                         
                                                                            
 lscht alle markierten Datenstze physikalisch in der Datei.               
 Die Markierung kann entweder mit "MarkCurrent <dbnr> 0" fr einen          
 speziellen Satz, oder mit                                                  
                                                                            
   UnMarkAll <dbnr>                                                         
                                                                            
 fr alle markierten Stze rckgngig gemacht werden.                       
                                                                            
ͼ
|
<SearchDB>
ͻ
 Suchen ohne Baum                                    Das Datenbankmodul  7  
Ķ
                                                                            
 Zur Suche mit komplexen Bedingungen ist der Befehl                         
                                                                            
   SearchDB <dbnr> <test> <ausg>                                            
                                                                            
 gedacht. Er geht die Datenbank Satz fr Satz durch und ruft fr jeden Satz 
 das Unterprogramm ab der Zeile <test> auf. Dieses kann mit "ReadDB" den    
 aktuellen Satz auf verschiedene Bedingungen testen und ruft "GefundenOK"   
 ohne Parameter auf, falls der Datensatz den gewnschten Bedingungen        
 entspricht. Ist dies der Fall, so ruft "SearchDB" das Unterprogramm <ausg> 
 auf, das die Bearbeitung oder Ausgabe des Satzes bernimmt. In beiden      
 Unterprogrammen kann die Suche mit dem parameterlosen Befehl "StopSearch"  
 beendet werden.                                                            
                                                                            
ͼ
|
<MakeTree>
ͻ
 Sortieren                                           Das Datenbankmodul  8  
Ķ
                                                                            
 Jede der Datenbanken kann fr eines der Zeichenfelder einen binren Baum   
 zur Sortierung aufbauen. Dies wird durch den Befehl                        
                                                                            
   MakeTree <dbnr> <feldnr>                                                 
                                                                            
 veranlat. Fr das (String-)Feld <feldnr> baut die Datenbank <dbnr> einen  
 Baum auf. Dieser kann mit                                                  
                                                                            
   DelTree <dbnr>                                                           
                                                                            
 explizit wieder gelscht werden, was aber automatisch geschieht, wenn      
 erneut "MakeTree" fr dieselbe Datenbank aufgerufen wird.                  
                                                                            
ͼ
|
<PassTree>
ͻ
 Nutzung des sortierten Baumes                       Das Datenbankmodul  9  
Ķ
 Die Funktion "PassTree" geht ebenso wie "SearchDB" die gesamte Datenbank   
 durch, jedoch in der Reihenfolge, die durch den Baum vorgegeben ist. Fr   
 jeden Datensatz wird wieder eine Test- und dann je nach Ergebnis eine      
 Bearbeitungs-/Ausgaberoutine aufgerufen. Die Syntax ist demnach dieselbe   
 wie bei "SearchDB" :                                                       
                                                                            
   PassTree <dbnr> <test> <ausg>                                            
                                                                            
 Zum direkten Auffinden eines Datensatzes eignet sich der Befehl:           
                                                                            
   SearchTree <dbnr> <ERGEBNIS> <str>                                       
                                                                            
 Er sucht <str> im Baum (<str> mu also in einem Feld stehen, da im Baum   
 sortiert wurde) und gibt die Dateiposition des gefundenen Satzes in        
 <ERGEBNIS> zurck. Der Wert 1 Milliarde bedeutet, da der Satz nicht ge-   
 funden wurde. Die Position ist mit "GoTo", nicht mit "GoToNr" direkt an-   
 steuerbar, sie wird auch automatisch gesetzt, wenn <str> gefunden wurde.   
ͼ
|
<ListTree>
ͻ
 Ausgabe des sortierten Baumes                       Das Datenbankmodul  10 
Ķ
                                                                            
 Um eine einfache Baumausgaberoutine handelt es sich bei:                   
                                                                            
   ListTree <dbnr>                                                          
                                                                            
 Der Bauminhalt wird (sortiert) wie mit "drucke" ausgegeben, also nicht in  
 irgendein Fenster.                                                         
                                                                            
ͼ
|
ͻ
 Der Prprozessor (c) 1991 toolbox                                        1 
Ķ
 Der Prprozessor wandelt ein Programm im Editor in ein TXL-ausfhrbares    
 Programm um. Er wird mit Ctrl-T im Editor aufgerufen. Nach Drcken dieser  
 Tastenkombination wird das Programm automatisch gespeichert, mit dem Pr-  
 prozessor in die Datei "AKTUELL.TXL" umgewandelt und automatisch in den    
 Programmspeicher eingelesen.                                               
                                                                            
 Die Verbesserungen durch den Prprozessor sind :                           
   - Wegfall der Zeilennumern am Anfang jeder Zeile                         
   - Ansteuerung von Unterprogrammen und Programmzeilen (gehezu und gosub)  
     mit Namen statt mit Zeilennummern                                      
   - Einfhrung von Bezeichnern fr Konstanten, die vom Prprozessor        
     automatisch eingesetzt werden.                                         
   - Leerzeilen sind mglich                                                
                                                                            
 Sowohl Programmzeilenbezeichnungen, als auch Konstanten knnen auch nach   
 ihrer ersten Bezeichnung noch definiert werden.                            
                                                                            
< weiter >ͼ
|
ͻ
 Die Prprozessorbefehle                                                  2 
Ķ
                                                                            
 1. label <name>                                                            
                                                                            
   ordnet der folgenden Zeile den Bezeichner <name> zu, der berall im      
   Programm verwendet werden kann.                                          
                                                                            
 2. const <name> <wert>                                                     
                                                                            
   definiert eine Konstante, die den Wert <wert> und die Bezeichnung <name> 
   hat.                                                                     
                                                                            
< weiter >ͼ
|
ͻ
 Ein Beispiel fr den Prprozessor                                        3 
Ķ
                                                                            
 gehezu haupt                                                               
                                                                            
 label Unterprogramm                                                        
   blockbegin                                                               
     drucke KONSTANTE                                                       
   blockend                                                                 
                                                                            
 label haupt                                                                
   ...                                                                      
   gosub Unterprogramm                                                      
   ...                                                                      
                                                                            
 const KONSTANTE 2000                                                       
                                                                            
ͼ
