/** Prototypen des Window-Moduls fr TXL 
    (c) 1991 by Elmar Warken  ***/

#define UChar unsigned char

typedef struct windowdata
{ 
  struct windowdata *NextWindow;
  char handle;
  char x1,y1,x2,y2,Breite,Hoehe;
  UChar FrameCol,BackCol,TopCol,BottomCol;
  char *BackGround, *HelpSave;
  char *TopL,*BottomL;
  char FrameType;
} WindowData;

void InitWindowSystem(void);
char *SaveBGround(int x1,int y1,int x2,int y2);
void RestoreBGround(int x1,int y1,int x2,int y2, char *BG);
void WriteFirstWin(int x, int y,char a, char *string);
void ClearFirstWin(void);
void FrameFirstWin(void);
void TopBottomFirstWin(char *top,char *bottom);
int OpenWindow(char nx1,char ny1,char nx2,char ny2,
	       UChar c1,UChar c2,UChar c3,UChar c4);
void CloseFirstWindow(void);
void HideWindow(struct windowdata *Win);
void ShowHiddenWindow(struct windowdata *Win);
void NewKoorWindow(char nx1,char ny1,char nx2,char ny2);
void ResizeWindow(int relx,int rely);
void MoveWindow(int relx,int rely);
struct windowdata *GetFirstWindow
	 (int number, struct windowdata *Win, struct windowdata *Prev);
void NewFirstWindow(int number);
void WR_STRMAX(char *str,unsigned char a,char max);  
void WinReadStr(char *frage, char *ergebnis, int laenge);
void Message(char *str);
int csetcursor(void);    
