/************************************************************************
*                .......................................                *
*                .                                     .                *
*                .       TOOLBOX - INTERPRETER         .                *
*                .       HEADERDATEI->TXL.C            .                *
*                .             GLOBAL.H                .                *
*                .    M.Beising & K.Bauer & TOOLBOX    .                *
*                .......................................                *
*************************************************************************/

#define wX 10
#define wY 10
#define wW 620
#define wH 250

extern PTNODE CreateTree(char Fktzeile[],int *ErrorPos,int *ErrorNr);
extern void DelTree(PTNODE *ptnode);
extern double Calc(PTNODE *ptnode);
extern float random(void);
extern void LiesDaten(void);
extern void SaveDaten(void);

extern BOOL FAR PASCAL TypeHelp(HWND, unsigned, WORD, LONG);
extern BOOL FAR PASCAL SetTextBox(HWND, unsigned, WORD, LONG);
extern BOOL FAR PASCAL HelpBox(HWND, unsigned, WORD, LONG);
extern BOOL FAR PASCAL Input(HWND, unsigned, WORD, LONG);
extern BOOL FAR PASCAL About(HWND, unsigned, WORD, LONG);
extern HANDLE FAR PASCAL OpenDlg(HWND, unsigned, WORD, LONG);
extern void menuecommand(HWND hWnd,WORD wParam);
extern void writeclipbrd(HWND hWnd,char *writestr);
extern void MakeHelpPathName(char *szFileName);
extern void readclipbrd(HWND hWnd,BOOL ausgabe);
extern void writeclipbrd(HWND hWnd,char *writestr);

PRGZEILE *FirstLine,*ActLine,NewLine,*LastLine,*WaitLine=NULL;
DWORD  dwTextlen,TOSCROLL;
OFSTRUCT fileInfo;
TEXTMETRIC tm;
FORARRAY forcalc[FORWHILETIEFE];

unsigned char Leerstring[81]= ">                                                                               ";
unsigned char Textstr[ZEILENLAENGE]= "?";
unsigned char Questr[ZEILENLAENGE];
unsigned char PrintBuf[ZEILENLAENGE];
LPSTR Ersetzstr=NULL;


char FileName[FNAMLEN];
char ReadBuffer[ZEILENLAENGE];
char Charakter,*LinePos;
char IntegerZahl[25];
char szAppName[10];
char szAbout[10];
char szMessage[30];
char *LinePos,ScanBuffer[ZEILENLAENGE];
char szHelpFileName[129];
VAR  *FirstVar = NULL;
VAR  Variable;
RECT rect;
HFONT oldFont,newFont;
HPEN hOldPen,hWeissPen,hBlackPen,hBlauPen,hGruenPen,hTurkisPen;
HPEN FARBPEN,hRedPen,hGrauPen,hViolettPen,hGelbPen;
HBITMAP hBitmap,hOldBitmap;
HANDLE hInst,hEditText;
FARPROC lpProcTextBox,lpprocAbout,lpProcTemp,lpOpenDlg;
HWND hWndglob,hWndEdit;
HDC hPrnDC;
LOGFONT mF;
HCURSOR hHelpCursor;

HBRUSH hOldBrush,hBlackBrush,hBlauBrush,hGruenBrush,hTurkisBrush,hRedBrush;
HBRUSH FARBBRUSH,hGrauBrush,hWeissBrush,hViolettBrush,hGelbBrush;
POINT pt;

BOOL RUNBREAK=FALSE,LoadFile=FALSE,bText=FALSE,PrMsgBox=FALSE,Mono = FALSE;
BOOL bHelp=FALSE,locate=FALSE,Edit=FALSE,TreeError=FALSE,IntError=TRUE,NeedNext;
BOOL bCaret=FALSE,Anfang=TRUE,FontChange=FALSE,Drucker=FALSE,Mehr=FALSE;

int Brush=0,MessageLength,Steuer,Zeile=0,GetNextLine;
int Backgrd=15,AktPos,ErrTyp,ErrPos,ErrNr,XW1,XW2,XW3,XW4,YW1,YW2,YW3,YW4;
int charcnt=0,TXW1=0,TYW1=8,TXW2=8,TYW2=500,TXW3=0,TXW4=0,TYW3=0;
int TORIENT=0,TESCP=0,TOutP=0,TCliP=0,TQual=0,TFam=10,oem=255,Pen=0;
int icnt,ini,ForCnt=0,TextCol=-1,x=0,fio,Readcnt=0;
unsigned int slen;
WORD  what;
DWORD FLOODFARBE,GRAU,GELB,TURKIS,ROT,GRUEN,VIOLETT,BLACK,WEISS,BLAU;

char *MFONT[]= { "System","Terminal",
                     "Helvetica","Courier",
                     "Tms Rmn","Roman",
                     "Script","Modern" };

TOKBEF  TokBefDesc[] = {
          { cinput,       "input"     ,       1,           1},
          { cwtitle,      "titlewindow",      1,           1},
          { crectangle,   "rectangle" ,       1,           1},
          { clineto,      "line"      ,       1,           1},
          { cellipse,     "ellipse"   ,       1,           1},
          { croundrect,   "roundrect" ,       1,           1},
          { carc,         "arc"       ,       1,           1},
          { csetpxl,      "setpixel"  ,       1,           1},
          { cmove,        "movewindow",       1,           1},
          { cpie,         "pie"       ,       1,           1},
          { csetprint,    "setprinter",       0,           0},
          { cplay,        "play"      ,       1,           1},
          { ccls,         "cls"       ,       0,           0},
          { crun,         "run"       ,       0,           0},
          { cdruck,       "print"     ,       0,           1},
          { cneu,         "new"       ,       0,           0},
          { cif,          "if"        ,       2,           1},
          { cload,        "load"      ,       1,           1},
          { csave,        "save"      ,       1,           1},
          { cgoto,        "goto"      ,       1,           0},
          { cende,        "end"       ,       0,           0},
          { cexit,        "system"    ,       0,           0},
          { cmerke,       "rem"       ,       0,           1},
          { clist,        "list"      ,       0,           1},
          { cset,         "let"       ,       3,           1},
          { cscreen,      "setscreen" ,       0,           0},
          { ctexttype,    "typeset"   ,       1,           1},
          { cllist,       "llist"     ,       1,           1},
          { clocate,      "locate"    ,       1,           1},
          { cpolyline,    "polyline"  ,       1,           1},
          { cflodfil,     "floodfill"  ,      1,           1},
          { ctextcol,     "settextcolor",     1,           1},
          { cbackgrd,     "setbkcolor",       1,           1},
          { ccolor,       "setcolor"  ,       1,           1},
          { cpencolor,    "setpencolor",      1,           1},
          { messagebox,   "msgbox"    ,       1,           1},
          { cviereck,     "viereck"   ,       1,           1},
          { crectline,    "rectline"  ,       1,           1},
          { cinline,      "inline"    ,       1,           1},
          { cfor,         "for"       ,       1,           1},
          { cnext,        "next"      ,       1,           1},
          { cwhile,       "while"     ,       1,           1},
          { cwend,        "wend"      ,       1,           1},
          { ccursor,      "cursor"    ,       1,           1},
          { crunb,        "runb"      ,       0,           0},
          { ccommands,    "commands"  ,       0,           0},
          { cbeep,        "messagebeep",      0,           0},
          { creadclp,     "readclipboard",    1,           1},
          { cwritclp,     "writeclipboard",   1,           1},
          { cneu,         "neu"       ,       0,           0},
          { crun,         "lauf"      ,       0,           0},
          { cmerke,       "merke"     ,       0,           1},
          { cdruck,       "drucke"    ,       0,           1},
          { cset,         "setze"     ,       3,           1},
          { cload,        "lade"      ,       1,           1},
          { csave,        "speichere" ,       1,           1},
          { cif,          "wenn"      ,       2,           1},
          { clist,        "liste"     ,       0,           1},
          { cgoto,        "gehezu"    ,       1,           0},
          { cexit,        "verlasse"  ,       0,           0},
          { cende,        "ende"      ,       0,           0},
          { NULL,         NULL        ,       0,           0}
};

