{$c-,u-,a+,v-,r-}   (* Compiler-Voreinstellungen *)

(*****************************************************************************)
(*                                                                           *)
(*         >>>>>>>>>>  Programm:    DISCUSS.PAS  (v3.0)  <<<<<<<<<<          *)
(*                                                                           *)
(*                             Kurvendiskussion                              *)
(*                                                                           *)
(*                              (c) 1986,87,88                               *)
(*               Karsten Gieselmann, Michael Ceol, Peter Engels              *)
(*                          & PASCAL International                           *)
(*                                                                           *)
(*****************************************************************************)


(* einige globale Variable und Konstante *)

CONST
{$I CALCCONS.PAS }
maxgrad = 2;

TYPE
{$I CALCTYPE.PAS }
strg = calc_string;

VAR
VarTable : Calc_VarTab;
ArgPos   : INTEGER;
FormProg : ARRAY [0..maxgrad] OF Calc_prog;
FuncTerm : Calc_String;
{$I CALCVAR.PAS }

{$I READSTR.INC }                         (* komfortable Stringeingabe       *)
{$I CALCUTIL.PAS }                        (* Hilfsroutinen fuer Calc         *)
{$I MATHFUNC.PAS }                        (* Funktionensammlung              *)
{$I CALC.PAS }                            (* Compiler und Interpreter        *)
{$I CALCGLOB.PAS }                        (* globale Prozeduren fuer Calcderi*)
{$I CALCSIMP.PAS }                        (* Vereinfachen von Calc-Termen    *)
{$I CALCSIM2.PAS }                        (*       "       "    " , Teil 2   *)
{$I CALCDERI.PAS }                        (* symbolisches Differenzieren     *)
{$I CALCAOS.PAS }                         (* Bildschirmausgabe               *)
{$I FORMULA.INC }                         (* erlaubt Eingabe von z.B. 1/7    *)
{$I HELLO.INC }                           (* Begruessung                     *)
{$I DEF.INC     }                         (* Parameter                       *)
{$I FUNCTION.INC}                         (* Funktionseingabe und Auswertung *)
{$I SOLVE.INC   }                         (* Loesen der Gleichung f(x)=0     *)
{$I INTERVAL.INC}                         (* Einlesen der Intervallparameter *)
{$I TABLE.INC   }                         (* Erstellen einer Wertetabelle    *)
{$I ROOTS.INC   }                         (* Berechnung der Nullstellen      *)
{$I EXTREME.INC }                         (*      -      -  Extremwerte      *)
{$I FLEX.INC    }                         (*      -      -  Wendestellen     *)
{$I INTEGRAL.INC}                         (* Integralberechnung              *)
{$I SYMMETRY.INC}                         (* Symmetrieueberpruefung          *)
{$I MONOTONY.INC}                         (* Monotonieueberpruefung          *)

(* Das folgende Modul muss fuer jeden Rechner angepasst werden !             *)
(* Hierin sind die speziellen Grafik-Prozeduren enthalten.                   *)
(* Es stehen bisher zur Verfuegung :

     DRAW .INC  : fuer IBM mit CGA-Karte
     DRAW2.INC  : fuer Schneider CPC 6128
     DRAW3.INC  : fuer Apple II+/e mit IBS AP22 - Karte
     DRAW4.INC  : fuer Apple II+/e mit normaler SoftCard                     *)


{$I DRAW.INC   }                         (* Funktionsgraph zeichnen         *)




{$I MENU3.INC   }                         (* Menuesteuerung                  *)

Begin
Menu
End.
