PROGRAM PLBGI;

USES GRAPH, HPGL, PLScript;

VAR
  GraphDriver,
  GraphMode    : Integer;
  Message      : STRING[80];

begin
  OpenGraphik ('PRN');                      (* Plotter aktivieren *)
  GraphDriver := Detect;                    (* Graphik-Befehle aktivieren *)
  InitGraph(GraphMode, GraphDriver, '');    (* korrektes Directory setzen ! *)

  SetBkColor (Blue);
  Graph.OutTextXY (10, 10, 'PLOTTER-SCHRIFT    (c) 1989 DMV-Verlag');
  Graph.OutTextXY (10, 80, ' Plotter am Arbeiten .. ');

  (* Schriftart, Richtung und Grsse festlegen : *)
  SetTextStyle (Goth, HorizDir, 0);
			     (* ^ Grsse, Bereich 1 .. 26 ODER  0 *)

  (* Falls CharSize auf 0 gesetzt wird, kann mit der folgenden Prozedur *)
  (* eine beliebige Schriftgrsse in x- und y-Richtung festgelegt werden *)
  (* Parameter : MultX, DivX, MultY, DivY *)
  SetUserCharsize (1, 2, 3, 4);

  (* Text ausrichten : *)
  SetTextJustify (LeftText, BottomText);
		 (*  ^---------^ vgl. Turbo-Handbuch *)

  Message := 'Toolbox ist eine tolle Kiste !';
  (*           ^-- auszugebender Text *)
  FillChar (Farbe, SizeOf (Farbe), Red);
  OutTextXY (30,150, Message);

  Message := 'I like TOOLBOX';
  SetTextStyle (Trip, HorizDir, 2);
  FillChar (Farbe, SizeOf (Farbe), Black);
  Farbe [3] := Cyan;  Farbe [4] := Cyan; Farbe [5] := Cyan; Farbe [6] := Cyan;
  Farbe [8] := Green;
  (* fr jedes Zeichen kann die Farbe festgelegt werden *)

  Graph.OutTextXY (10, 150, Message);

  OutTextXY (30, 100, Message);   (* Text plotten *)
	 (*   ^---^ in mm ! *)
END.