/** Prototypen des Datenbankmoduls **/
/** (c) 1991 Elmar Warken ***********/

typedef int (*TestFunktion)(void);
typedef void (*AusgabeFunktion)(void);

void AddDefinition(int defnr, int typ, int len);
int OpenFile(int defnr, char *name);
int CreateFile(int defnr, char *name);
void BeschreibeSatz(int defnr, int feldnr, char *str, int wert);
void LeseSatz(int defnr, int feldnr, char *str, int *wert);
void WriteToFile(int defnr);
void GotoFileEnd(int defnr);
void GotoFileBegin(int defnr);
void GoForward(int defnr);
void GoBackward(int defnr);
void GoTo(int defnr, long satzpos);
void GoToNr(int defnr, int satznr);
void MarkCurrent(int defnr, int Mark_On);
void CloseFile(int defnr);
int T_ImmerWahr(void); 
void A_AddTree(void);
void DurchSuche(int defnr, TestFunktion t, AusgabeFunktion a);
void MakeTree(int defnr, int feldnr);
void DelMarked(int defnr);
void DelTree(int defnr);
void ListTree(int defnr);
void DurchsucheTree(int defnr, TestFunktion t, AusgabeFunktion a);
int CreateTree(int defnr, int feldnr);
int AddTree(int defnr, long filepos, char *str);
int SearchTree(int defnr, long *filepos, char *str);
void UnMarkAll(int defnr);
