/* intglob.c
Dieses File enthlt alle Globalvariablen des Interpreters.
(c) 1990 Michael Beising & TOOLBOX
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	"interp.h"


/*	Initialisieren der Befehlsvergleichsliste */

TOKBEF	TokBefDesc[] = {
/*    Funktion  Bef.-Name	 Para-Count		CopyRest */
	{ cexit,        "exit"          ,       0,                      0},
	{ crun,		"lauf"		,	0,			0},
        { crun,         "run"           ,       0,                      0},
	{ cdruck,	"drucke"	,	0,			1},
	{ cset,		"setze"		,	3,			1},
	{ cif,		"wenn"		,	2,			1},
	{ cload,	"lade"		,	1,			1},
	{ csave,	"speichere"	,	1,			1},
	{ cgoto,	"gehezu"	,	1,			0},
	{ cende,	"ende"		,	0,			0},
	{ cexit,	"verlasse"	,	0,			0},
	{ cmerke,       "merke"         ,       0,                      1},
	{ clist,        "liste"         ,       0,                      1},
	{ cneu,         "neu"           ,       0,                      0},
/*    NEUE BEFEHLE    */
	{ cinfo,        "info"          ,       0,                      0},
	{ cpiep,        "piep"          ,       0,                      0},
	{ cgerald,      "gerald"        ,       0,                      0},
	{ chilfe,       "hilfe"         ,       1,                      1},
	{ czeig,        "zeig"          ,       4,                      1},
	{ csetfarbe,    "setfarbe"      ,       2,                      1},
	{ cloesch,      "loesch"        ,       4,                      1},
	{ cpause,       "pause"         ,       0,                      0},
	{ cdos,         "dos"           ,       1,                      1},
	{ csbild,       "sbild"         ,       5,                      1},
	{ crbild,       "rbild"         ,       5,                      1},
	{ clese,        "lese"          ,       4,                      1},
	{ ciftaste,     "iftaste"       ,       1,                      1},
	{ cbox,		"box"		,	5,			1},
	{ cattribut,	"attribut"	,	6,			1},
	{ ccommands,    "commands"      ,       0,                      0},
/*  WEITERE NEUE BEFEHLE   */   
	{ cstrdef,	"strdef"	,	2,			1},
	{ cstrset,	"strset"	,	2,			1},
	{ cbegin,	"blockbegin"	,	0,			0},
	{ cend,		"blockend"	,	0,			0},
	{ creadln, 	"readln"	,	1,			1},
	{ cgosub,	"gosub"		,	1,			1},
	{ cDefArray,	"DefArray"	,	4,			1},
	{ cSetArrayElem,"SetArrayElem"	,	5,			1},
	{ cGetArrayElem,"GetArrayElem"	,	5,			1},
	{ citostr,	"itostr"        ,	2,                      1},
	{ cstrtoi, 	"strtoi"	,       2,			1},
	{ crandom,	"random"	,       2,                      1},
	{ crandomize,	"randomize"	,	0,			0},
/*  Befehle fr Fenster und Editor   */
	{ cneuedit,	"edit"		,	1,			1},
	{ cwindow,	"openwindow"	,	8,			1},
	{ cclosewindow,	"closewindow"	,	8,			1},
	{ csetcursor, 	"setcursor"	,	2,			1},
	{ csetfkey,	"setfkey"	,	2,			1},
	{ csetlinebuf,	"setlinebuf"	,	1,			1},
	{ cwindowfirst, "newfirstwindow",       1,			1},
	{ cinitedit,	"initeditor"	,	2,			1},
	{ cendedit,	"closeeditor"	,	1,			1},
	{ ceditorproc,	"editorproc"	,	1,			1},
	{ cshoweditor,	"showeditor"	,	1,			1},
	{ cinsertstring,"insertstring"  ,	2,			1},
	{ cedfunction,  "edfunction"	,	3,			1},
	{ cNewWinKoor,	"newwindowkoor" ,	4,			1},
	{ cResizeWin,	"resizewindow"	,       2,			1},
	{ cMoveWin,	"movewindow"	,       2,			1},
	{ cGetEdWord,   "getedword"	,       2,			1},
	{ cGetEdString, "getedstring"	,       1,			1},
	{ cWinReadStr,  "winreadstring"	,	3,			1},
	{ cWinMessage,	"winmessage"	,	1,			1},
	{ cWinWrite,	"winwrite"	,	4,			1},
	{ cReadKey,	"readkey"	,	1,			1},
/* Datenbankbefehle                  -- Parameterzahl unwichtig */
	{ cGotoBegin,	"GotoBegin" 	,	5,			1},
	{ cGotoEnd,     "GotoEnd"       ,	5,			1},
	{ cGoBackward,  "GoForward"     ,	5,			1},
	{ cGoForward,   "GoBackward"    ,	5,			1},
	{ cGoTo,        "GoTo"          ,	5,			1},
	{ cGoToNr,      "GoToNr"        ,	5,			1},
	{ cCloseFile,   "CloseFile"     ,	5,			1},
	{ cMakeTree,    "MakeTree"      ,	5,			1},
	{ cMarkCurrent, "MarkCurrent"   ,	5,			1},
	{ cUnMarkAll,   "UnMarkAll"     ,	5,			1},
	{ cDelTree,     "DelTree"       ,	5,			1},
	{ cDelMarked,   "DelMarked"     ,	5,			1},
	{ cListTree,    "ListTree"      ,	5,			1},
	{ cStopSearch,  "StopSearch"    ,	5,			1},
	{ cGefundenOK,  "GefundenOK"    ,	5,			1},
	{ cSearchDB,    "SearchDB"      ,	5,			1},
	{ cSearchTree,  "SearchTree"    ,	5,			1},
	{ cDurchsucheTree,"PassTree"    ,	5,			1},
	{ cdefDB,       "DefDB"         ,	5,			1},
	{ copenDB,      "OpenDB"        ,	5,			1},
	{ ccreateDB,    "CreateDB"      ,	5,			1},
	{ cWriteDB,     "WriteDB"       ,	5,			1},
	{ cReadDB,      "ReadDB"        ,	5,			1},
	{ cAddDB,       "AddDB"         ,	5,			1},
        { cReadDBFormat,"ReadDBForm"    ,       3,                      1},   
/* Men und Stack */
	{ cMenue,	"menue"         ,	5,			1},
	{ cpush,        "push"          ,	5,			1},
	{ cpop,         "pop"           ,	5,			1},
	{ cAuswahl,	"auswahl"	,	5,			1},
/* Prprozessorbefehle */
	{ cdummy,       "const"         ,	0,			0},
	{ cdummy,       "label"         ,	0,			0},
	{ NULL,         NULL            ,       0,                      0}
};

/* Globale Variable des Interpreters */
int			IntError;		/* Interpreterfehler ist aufgetreten. */

PRGZEILE	*FirstLine;		/* erste Interpreterzeile */
PRGZEILE	*LastLine;		/* letzte Interpreterzeile */
PRGZEILE	*ActLine;		/* aktuelle interpretierte Zeile */
char		*LinePos;		/* Zeilenposition der aktuellen Zeile*/

int			Steuer;			/* Scanner-Ergebnis */
char		ScanBuffer[ZEILENLAENGE]; /* Ergebnis des Scanners */

VAR		*FirstVar = NULL;	/* Zeiger auf die erste Variable */

char	FileName[FNAMLEN];	/* Zwischenspeicher fr den Filenamen */

/* Ende des Files INTGLOB.C */
